<?php
/**
 * Created By       : Sergey Jdanuk aka Shadoof <jdanuk at gmail.com>
 * Created Date     : 28.12.12 17:19
 *
 * Description      :
 *
 * History          :
 *
 * File name        : stb.php
 */
class Stb
{
    static $token = "";
	static $login ="";
    public static function token(){
	    return Cookie::get('token');
    }

	public static function login(){
		return Cookie::get('login');
	}
    public static function getServerUrl(){

        $serverConfig = Rise::$config->load('server');

        return sprintf(
//            "%s/%s?token=%s"
            "%s/%s?"
            , $serverConfig['host']
            , $serverConfig['url.stb.auth']
//            , Stb::token()
        );

    }

	public static function getGategoriesUrl()
	{

		$serverConfig = Rise::$config->load('server');

		return sprintf(
//			"%s/%s?token=%s"
			"%s/%s?"
			, $serverConfig['host']
			, $serverConfig['url.stb.get_categories']
//			, Stb::token()
		);

	}

	public static function getChannelsUrl(){

		$serverConfig = Rise::$config->load('server');

		return sprintf(
//			"%s/%s?token=%s"
			"%s/%s?"
			, $serverConfig['host']
			, $serverConfig['url.stb.get_channels']
//			, Stb::token()
		);

	}

    public static function getGenresUrl(){

        $serverConfig = Rise::$config->load('server');

        return sprintf(
//            "%s/%s?token=%s"
            "%s/%s?"
            , $serverConfig['host']
            , $serverConfig['url.stb.get_genres']
//            , Stb::token()
        );

    }

	public static function getNotificationsUrl() {
		$serverConfig = Rise::$config->load('server');
		return sprintf(
			"%s/%s?"
			, $serverConfig['host']
			, $serverConfig['url.stb.get_notifications']
		);
	}

	public static function getEpgUrl($channel_id, $epg_date, $seek=0)
	{
		echo "###################### " . get_time_zone();

		$serverConfig = Rise::$config->load('server');

		return sprintf(
			"%s/%s/%d/%s?token=%s&gmt=%s&%d"
//			"%s/%s/%d/%s?gmt=%s&"
			, $serverConfig['host']
			, $serverConfig['url.stb.get_epg']
			, (int)$channel_id
			, $epg_date
			, Stb::token()
            , get_time_zone() // Смещение временной зоны в секундах. Для временных зон, расположенных западнее UTC возвращаются
                        // отрицательные числа, а расположенных восточнее UTC - положительные.
			,$seek
		);

	}

	public static function getTvRecordedLink($channel_id, $start, $end)
	{
		$pid = $channel_id;
		$serverConfig = Rise::$config->load('server');

		$startEndParams = '';
		if( is_integer($start) )
		{
			$startEndParams = '&start='.$start;
			if (!is_null($end))
				$startEndParams .= '&end='.$end;
		}

        $url = sprintf(
//            "%s/%s/%d.m3u8?token=%s&pid=%d%s&ignore_me=.m3u8"
           "%s/%s/%d.m3u8?token=%s&login=%s&pid=%d%s&ignore_me=.m3u8&"
			// "%s/%s/%d.m3u8?pid=%d%s&ignore_me=.m3u8&"
//            , $serverConfig['host']
            , $serverConfig['npvr_host']
            , $serverConfig['url.stb.get_link']
            , (int)$channel_id
//            , Stb::token()
			, Stb::token()
			, Stb::login()
			, $pid
            , $startEndParams
        );
		return str_replace("https://", "http://", $url);

	}

    public static function getCheckAdultPasswordUrl() {
        $serverConfig = Rise::$config->load('server');

        return sprintf(
            "%s/%s?token=%s"
//            "%s/%s?"
            , $serverConfig['host']
            , $serverConfig['url.stb.check_adult_password_url']
            , Stb::token()
        );
    }

	public static function get_http_request ($url) {
		$new_url = $url . "token=" . Stb::token();
		$result = HD::http_get_document( $new_url );

		// Формат полученных данных - json
		// поэтому декодируем их в объект.
		$res = json_decode($result, true);

		if( isset($json['code']) && ($json['code'] != REQUEST_CODE_OK) ) {
			$available_codes = array(
				REQUEST_CODE_USER_NOT_FOUND,
				REQUEST_CODE_USER_NOT_ACTIVE,
			);

			if (in_array($json['code'], $available_codes)) {
				Cookie::set('password','',0);
			}

			if ($json['code'] == REQUEST_CODE_TOKEN_EXPIRED) {
				$login = Cookie::get('login');
				$password = Cookie::get('password');

				if( empty($login) || empty($password) ) {
					return array
					(
						GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
						GuiAction::params =>array(
							'selected_media_url' => Media_Url::encode("Welcome->play",array('action'=>'showLoginDialog'))
						)
					);
				}
				try {
					Stb_Auth::login( $login, $password);
					Stb::get_http_request($url);
				}
				catch(ErrorException $e) {
					$errors = json_decode($e->getMessage());
					return ActionFactory::show_error(true, 'Ошибка', $errors);
				}
			}
			else {
				throw new ErrorException(json_encode(array('Authorization got the error:', $json['error'])));
			}
		}

		if( $res['code'] != REQUEST_CODE_OK )
			throw new ErrorException( json_encode($res['message']) );

		return $res;
	}
}
