<?php
/**
 * Created By       : Sergey Jdanuk aka Shadoof <jdanuk at gmail.com>
 * Created Date     : 28.12.12 16:58
 *
 * Description      :
 *
 * History          :
 *
 * File name        : auth.php
 */
class Stb_Auth {


    /**
     * @static
     * @param $deviceModel
     * @param $serialNumber
     * @param $macAddress
     * @return mixed
     */
    static function login($login, $password){

	    $deviceModel    = sprintf("Dune HD %s", DuneBox::get_product_id());
	    $serialNumber   = DuneBox::get_serial_number();
	    $macAddress     = DuneBox::get_mac_addr();

        $serverConfig = Rise::$config->load('server');

        $url = sprintf(
            "%s/%s"
            ,$serverConfig['host']
            ,$serverConfig['url.stb.auth']
        );

        $result = HD::http_post_document( $url, array(
		        'login'=>$login,
		        'password'=>$password,
                'model'=>$deviceModel,
                'sn'=>$serialNumber,
                'mac'=>$macAddress
            )
        );

	    $json = json_decode( $result, TRUE );
		hd_print( print_r($json, true) );

        if( isset($json['error']) )
        {

            $available_codes = array(
                REQUEST_CODE_WRONG_PASSWORD,
                REQUEST_CODE_USER_NOT_FOUND,
                REQUEST_CODE_NOT_ENOUGH_AUTH_DATA,
                REQUEST_CODE_USER_NOT_ACTIVE,
                REQUEST_CODE_NOT_PROVIDED_MODEL_OR_SN,
                REQUEST_CODE_DEVICE_NOT_FOUND,
                REQUEST_CODE_PLUGIN_DISABLED
            );

            if (in_array($json['code'], $available_codes)) {
                Cookie::set('password','',0);
            }

	        throw new ErrorException(json_encode(array('Authorization got the error:', $json['error'])));
        }

        Stb::$token = $json['token'];
        Cookie::set('token', $json['token'],0);

		return $json;
    }

	static function loadTokenFromFile(){
		$file = Rise::$config->load('account.mw_file');

		if( !file_exists($file) )
			throw new Exception('File ' . $file . ' not found');

		$contents = file_get_contents($file);
		$json = json_decode($contents, TRUE);
		Stb::$token = $json['token'];
		Cookie::set('token', $json['token'],0);
	}
}