<?php
class Controller implements DunePlugin
{
    public function get_folder_view($media_url, &$plugin_cookies)
    {
        echo 'get_folder_view';
        Cookie::init($plugin_cookies);

		if( $media_url == 'dummy' )
			return array('');
		$mediaUrl = Media_Url::decode($media_url);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy' ) || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$method = $screen['method'];
		$params = (array)$mediaUrl->params;
		return call_user_func_array(array($object,$method),$params);
    }

    public function get_next_folder_view($media_url, &$plugin_cookies)
    {
        echo 'get_next_folder_view';
        Cookie::init($plugin_cookies);
		if( $media_url == 'dummy' )
			return array('');
		$mediaUrl = Media_Url::decode($media_url);
		if( $mediaUrl->selected_media_url == 'dummy' || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$method = $screen['method'];
		$params = (array)$mediaUrl->params;
		return call_user_func_array(array($object,$method),$params);
    }

    public function get_tv_info($media_url, &$plugin_cookies)
    {
        echo 'get_tv_info';
        Cookie::init($plugin_cookies);
		if( $media_url == 'dummy' )
			return array('');
		$mediaUrl = Media_Url::decode($media_url);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy') || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$method = $screen['method'];
		$params = (array)$mediaUrl->params;
		return call_user_func_array(array($object,$method),$params);
    }

    public function get_tv_stream_url($media_url, &$plugin_cookies)
    {
        echo 'get_tv_stream_url';
        Cookie::init($plugin_cookies);
		$mediaUrl = Media_Url::decode($media_url);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy' ) || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		return call_user_func_array(array($object,__FUNCTION__),func_get_args());
//        return Screen::_get_tv_stream_url($media_url);
    }

    public function get_vod_info($media_url, &$plugin_cookies)
    {
        echo 'get_vod_info';
        Cookie::init($plugin_cookies);
		if( $media_url == 'dummy' )
			return array('');
		$mediaUrl = Media_Url::decode($media_url);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy') || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$method = $screen['method'];
		$params = (array)$mediaUrl->params;
		return call_user_func_array(array($object,$method),$params);
    }

    public function get_vod_stream_url($media_url, &$plugin_cookies)
    {
        echo 'get_vod_stream_url';
    }

    public function get_regular_folder_items($media_url, $from_ndx, &$plugin_cookies)
    {
        echo 'get_regular_folder_items';
        Cookie::init($plugin_cookies);
		if( $media_url == 'dummy' )
			return array('');
		$mediaUrl = Media_Url::decode($media_url);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy' ) || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$method = $screen['method'];
		$params = (array)$mediaUrl->params;
		$params = array_merge(array($from_ndx), $params);
		return call_user_func_array(array($object,$method.'Regular'),$params);
    }

    public function get_day_epg($channel_id, $day_start_ts, &$plugin_cookies)
    {
        echo 'get_day_epg';
        Cookie::init($plugin_cookies);
		$mediaUrl = Media_Url::decode($channel_id);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy' ) || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$params = (array)$mediaUrl->params;
		$args = func_get_args();
		$args[0] = $params['channel_id'];
		return call_user_func_array(array($object,__FUNCTION__),$args);

//        return Screen::_get_day_epg($channel_id, $day_start_ts);
    }

    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
        echo 'get_tv_playback_url: ' . $channel_id;
        Cookie::init($plugin_cookies);
		$mediaUrl = Media_Url::decode($channel_id);
		if( (isset($mediaUrl->selected_media_url) && $mediaUrl->selected_media_url == 'dummy' ) || $mediaUrl->media_url == 'dummy' )
			return array('');
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		$params = (array)$mediaUrl->params;
		$args = func_get_args();
		$args[0] = $params['channel_id'];
		return call_user_func_array(array($object,__FUNCTION__),$args);
//        return Screen::_get_tv_playback_url($channel_id, $archive_ts, $protect_code);
    }

	public function change_tv_favorites($fav_op_type, $channel_id, &$plugin_cookies)
	{
		$fav_channel_ids = $this->get_fav_channel_ids($plugin_cookies);

		if ($fav_op_type === PLUGIN_FAVORITES_OP_ADD)
		{
			array_push($fav_channel_ids, $channel_id);
		}
		else if ($fav_op_type === PLUGIN_FAVORITES_OP_REMOVE)
		{
			$k = array_search($channel_id, $fav_channel_ids);

			if ($k !== false)
				unset ($fav_channel_ids[$k]);
		}
		else if ($fav_op_type === PLUGIN_FAVORITES_OP_MOVE_UP)
		{
			$k = array_search($channel_id, $fav_channel_ids);

			if ($k !== false && $k !== 0)
			{
				$t = $fav_channel_ids[$k - 1];
				$fav_channel_ids[$k - 1] = $fav_channel_ids[$k];
				$fav_channel_ids[$k] = $t;
			}
		}
		else if ($fav_op_type === PLUGIN_FAVORITES_OP_MOVE_DOWN)
		{
			$k = array_search($channel_id, $fav_channel_ids);

			if ($k !== false && $k !== count($fav_channel_ids) - 1)
			{
				$t = $fav_channel_ids[$k + 1];
				$fav_channel_ids[$k + 1] = $fav_channel_ids[$k];
				$fav_channel_ids[$k] = $t;
			}
		}

		$this->set_fav_channel_ids($plugin_cookies, $fav_channel_ids);

		return ActionFactory::invalidate_folders(
			array(
				json_encode(
					array(
						'screen_id'    => 'tv_favorites',
						'is_favorites' => true))
			));
	}

	///////////////////////////////////////////////////////////////////////

	public function get_fav_channel_ids(&$plugin_cookies)
	{
		$fav_channel_ids = array();

		if (isset($plugin_cookies->{'favorite_channels'}))
			$fav_channel_ids = preg_split('/,/', $plugin_cookies->{'favorite_channels'});

		return $fav_channel_ids;
	}

	///////////////////////////////////////////////////////////////////////

	public function set_fav_channel_ids(&$plugin_cookies, &$ids)
	{
		$plugin_cookies->{'favorite_channels'} = join(',', $ids);
	}

    public function handle_user_input(&$arg, &$plugin_cookies)
    {
        hd_print(sprintf('handle_user_input(%s)', json_encode($arg)));

        Cookie::init($plugin_cookies);
		$mediaUrl = "";
		if( isset($arg->control_id) && ( $arg->control_id == 'search' || $arg->control_id == 'searchResult' ) )
		{
			$mediaUrl = Media_Url::decode($arg->parent_media_url);
		}
		else if(isset($arg->selected_media_url))
		{
			if( $arg->selected_media_url == 'dummy' )
				return array('');

			$mediaUrl = Media_Url::decode($arg->selected_media_url);
		}
		if( !isset($mediaUrl->media_url) || empty($mediaUrl->media_url))
		{
			print_r($arg);
			throw new Exception("Media url is empty - screen.php:".__LINE__);
		}
		$screen = Screen_Collection::findOrCreate($mediaUrl->media_url);
		$object = $screen['object'];
		return $object->input($arg);
    }
}
?>
