<?php 

class Cookie
{
    static $cookie;
    
    static function init(&$plugin_cookie)
    {
        self::$cookie = $plugin_cookie;
    }
    
    static function get($key = NULL, $default = NULL)
    {
        if( is_null($key) )
        {
            return self::$cookie;
        }
        return isset(self::$cookie->$key) ? self::$cookie->$key : $default;
    }
    
    static function set($key, $val, $expire)
    {
        self::$cookie->$key = $val;

	    $expire = intval($expire);
	    if( $expire > 0 )
	    {
		    $key_expire = $key."_expire";
		    $key_savedTime = $key."_savedTime";
		    self::$cookie->$key_expire = $expire;
		    self::$cookie->$key_savedTime = time();
	    }
    }

	static function expired($key)
	{
		$key_expire = $key."_expire";
		if( isset(self::$cookie->$key_expire) )
		{
			$key_savedTime = $key."_savedTime";
			$key_expire = intval(self::$cookie->$key_expire);
			return time() - self::$cookie->$key_savedTime > $key_expire;
		}
		return true;
	}
}
