<?php
/**
 * Created by JetBrains PhpStorm.
 * User: debian
 * Date: 03.07.14
 * Time: 17:52
 * To change this template use File | Settings | File Templates.
 */
class Screen_Collection {
	static $screens = array();
	static function add( $object )
	{
		$obj = self::prepare($object);
		self::$screens[] = $obj;
		return $obj;
	}
	static function prepare( $object )
	{
		return (object)array('handler'=>$object);
	}

	static function explode($delimeter, $call)
	{
		$tmp = explode('->',$call);
		$name = $tmp[0];
		$method = NULL;
		$params = array();

		if(count($tmp)>1)
		{
			$params = explode('/',$tmp[1]);
			if(count($params))
			{
				$method = $params[0];
				unset($params[0]);
			}
		}
		return array
		(
			'name'=>$name,
			'method'=>$method,
			'params'=>$params
		);
	}

	static function find( $call )
	{
		$classInfo = self::explode('->',$call);
		foreach( self::$screens as $i)
		{
			if( get_class( $i->handler ) == $classInfo['name'] )
			{
				return array(
					'object'=>$i->handler,
					'method'=>$classInfo['method'],
					'params'=>$classInfo['params'],
				);
			}
		}
		return FALSE;
	}

	static function findOrCreate($call)
	{
		$screen = Screen_Collection::find($call);
		if( $screen === FALSE )
		{
			$classInfo = Screen_Collection::explode('->', $call);
			$className = $classInfo['name'];

			// Если ничего не нашли, пытаемся создавать новый объект вызываемого класса
			//
			// Чтобы cоздаваевый класс попал в список screens,
			// он должен быть наследован от класса Screen
			new $className();

			// Пытаемся еще раз найти объект
			$screen = Screen_Collection::find($call);
			if( $screen === FALSE )
			{
				throw new Exception("The class $className isn't extended of Screen");
			}
		}
		return $screen;
	}
}